/* Copyright (c) 2004 Yutaka Sato. All rights reserved.
 *
 * any2fdif.c
 *
 * 040602 created as a HTML to MAIL converter
 * 040609 extended to a FDIF generator taking generic input types
 *
 */
#include <stdio.h>
#include "ystring.h"
#include <ctype.h>
#include <sys/types.h>
#ifdef _MSC_VER
#include "../include/ywinsock.h" /* for htonl() */
#else
#include <arpa/inet.h> /* for htonl() */
#endif

extern int isFullURL();
extern FILE *URLget();
extern char *DELEGATE_verdate();

extern char *RFC822_fgetsHeaderField();
extern char *wordscanX();
extern char *valuescanX();
extern char *wbstrcpy();
extern scanMeta();
extern fscanTag();
extern char *strskip();
extern char *strcasestr();
extern int scanNNTPtime();
extern char *strtailstr();
extern char *getenv();
extern double Time();
static double Start;
extern backseek(FILE *in, int off);

#ifdef MAIN
VSocket(){}
fullpathSUCOM(){}
BeforeExec(){}
int isFullURL(){
	return 0;
}
FILE *URLget(){
	fprintf(stderr,"URLget() is not available.\n");
	return 0;
}
char *DELEGATE_verdate(){
	return 0;
}
main(int ac,char *av){
	return any2fdif_main(ac,av);
}
#endif

extern FILE *getTmp();
#define TMP0	0
#define TMP1	1
#define TMP2	2
#define TMP3	3
#define TMP4	4
#define TMP5	5

static char *ccx_outcode = "a-b-r-EUC-JP";

extern MIME_rewaddrs();
static char *hide_addr = "From:%l@%r..%c";

static char *indexbase = "freyasx/bank";

#define T_TEXT	1
#define T_MAIL	2
#define T_HTML	3
#define T_HTTP	4
#define T_JS	5
#define T_MBOX	6

#define CH_COPYR	0xA9
static char thru8[32] = {CH_COPYR};
static int Itype = T_HTML;

typedef struct {
	int	opt_v;
	int	opt_d;
	int	opt_u;
	int	opt_a;
	int	printIfText;
	int	NumAny;
	int	NumUrl;
	int	NumPut;
	int	MaxPut;
	int	Codes[1000];
	int	withAuthor;
	int	guessedAuthor;
	void	*UrlSed;
	char	*UrlMount[2];

	int	Fsize;
	int	Mtime;
	int	Atime;

	FILE	*Out;
	FILE	*Descf;
	FILE	*Summf;

	char	Url[1024];
	char	Descr[1024];
	char	Keywd[1024];
	char	Title[1024];
	char	Heads[1024];
	char	Author[1024];
	char	Address[1024];
	char	Links[2048];
	char	Location[1024];
	char	XUri[1024];
	char	XRefs[1024];
	int	Ccx[64];
	int	CCXdisable;
} AFEnv;

static AFEnv *AFenv;
#define opt_v		AFenv->opt_v
#define opt_d		AFenv->opt_d
#define opt_u		AFenv->opt_u
#define opt_a		AFenv->opt_a
#define printIfText	AFenv->printIfText
#define NumAny		AFenv->NumAny
#define NumUrl		AFenv->NumUrl
#define NumPut		AFenv->NumPut
#define MaxPut		AFenv->MaxPut
#define Codes		AFenv->Codes
#define withAuthor	AFenv->withAuthor
#define guessedAuthor	AFenv->guessedAuthor
#define UrlSed		AFenv->UrlSed
#define UrlMount	AFenv->UrlMount
#define Fsize		AFenv->Fsize
#define Mtime		AFenv->Mtime
#define Atime		AFenv->Atime
#define Out		AFenv->Out
#define Descf		AFenv->Descf
#define Summf		AFenv->Summf
#define Url		AFenv->Url
#define Descr		AFenv->Descr
#define Keywd		AFenv->Keywd
#define Title		AFenv->Title
#define Heads		AFenv->Heads
#define Author		AFenv->Author
#define Address		AFenv->Address
#define Links		AFenv->Links
#define Location	AFenv->Location
#define XUri		AFenv->XUri
#define XRefs		AFenv->XRefs
#define Ccx		AFenv->Ccx
#define CCXdisable	AFenv->CCXdisable

#define MAX_TYPES	128
/*
 * screening by suffix of URL
 * this table should be loadable from any2fdif.conf
 */
static struct {
	char	*ext;
	int	 itype;
	char	*cnv;
	int	 cnt;
	int	 ixs[8];
} types[MAX_TYPES] = {
	{"",      T_HTTP}, /* undefined extensions */
	{"/",     T_HTML},
	{"/MAIL", T_MAIL},
	{"htm",   T_HTML},
	{"html",  T_HTML},
	{"shtml", T_HTML},
	{"txt",   T_TEXT},
	{"cgi",   T_HTTP},
	{"asp",   T_HTTP},
	{"jsp",   T_HTTP},
	{"php",   T_HTTP},
	{"php3",  T_HTTP},
	{"fcg",   T_HTTP},
	{"exe",   T_HTTP},
	{"pl",    T_HTTP},
	{"c",     T_TEXT},
	{"cc",    T_TEXT},
	{"h",     T_TEXT},
	{"o"},
	{"a"},
	{"js"},

	{"gif"},
	{"jpg"},
	{"swf"},
	{"css"},
	{"png"},
	{"ico"},
	{"jpeg"},
	{"pdf"},

	{"bmp"},
	{"asx"},
	{"curl"},
	{"dmg"},
	{"mov"},
	{"mid"},
	{"mpg"},
	{"pjpeg"},
	{"ram"},
	{"ras"},
	{"rm"},
	{"sit"},
	{"wav"},
	{"wmv"},
	{"xbm"},
	{"xpi"},
	
	{"bin"},
	{"bz2"},
	{"gz"},
	{"hqx"},
	{"ipk"},
	{"lzh"},
	{"rpm"},
	{"tar"},
	{"tgz"},
	{"zip"},
	
	{"doc"},
	{"ppt"},
	{"ps"},
	{"xml"},
	0
};
static setConv(ext,cnv)
	char *ext,*cnv;
{	int xi;
	char *cext;

	for( xi = 0; cext = types[xi].ext; xi++ ){
		if( strcaseeq(ext,cext) ){
			types[xi].cnv = strdup(cnv);
			return;
		}
	}
	if( xi < MAX_TYPES ){
		types[xi].ext = ext;
		types[xi].itype = T_TEXT;
		types[xi].cnv = strdup(cnv);
	}
}
static char *getConv(path)
	char *path;
{	char *ext,*cext;
	int xi;

	if( (ext = strrchr(path,'.')) == 0 )
		return 0;
	ext++;

	for( xi = 0; cext = types[xi].ext; xi++ ){
		if( strcaseeq(ext,cext) ){
			return types[xi].cnv;
		}
	}
	return 0;
}

static doindextype(url,ixp)
	char *url;
	int *ixp;
{	int xi;
	char *ext,*cext;
	char *dp,*qp,*cp,cch;

	if( cp = strtailstr(url,"/@") ){
		cch = cp[1];
		cp[1] = 0;
	}else
	if( cp = strtailstr(url,"/=") ){
		cch = cp[1];
		cp[1] = 0;
	}
	if( qp = strchr(url,'?') )
		*qp = 0;

	ext = 0;
	if( strtailchr(url) == '/' )
		ext = "/"; 
	else
	if( dp = strrchr(url,'/') ){
		if( dp = strrchr(dp+1,'.') )
			ext = dp + 1;
		else	ext = "";
	}

	if( ext == 0 ){
		xi = 0;
		goto EXIT;
	}
	for( xi = 0; cext = types[xi].ext; xi++ ){
		if( *cext && strcaseeq(ext,cext) )
			goto EXIT;
	}
	xi = 0;
EXIT:
/*
if( xi == 0 && *ext != 0 ) fprintf(stderr,"+++ [%s] %s\n",ext,url);
*/
	if( cp ) cp[1] = cch;
	if( qp ) *qp = '?';
	types[xi].cnt += 1;
	*ixp = xi;
	return types[xi].itype;
}

#define E_OK		0
#define E_EOF		1
#define E_CTRL		2
#define E_ENCODED	3
#define E_NONTEXT	4
#define E_BINARY	5
#define E_EMPTY		6
#define E_DIR		7

static dumptypes(){
	int xi,cnt;
	char *cext;
	int i,total;

	total = 0;
	for( xi = 0; cext = types[xi].ext; xi++ ){
		total += types[xi].cnt;
	}

 fprintf(stderr,"suffix  count  ratio indexed ctrl ntxt encd  bin null  dir\n");
 fprintf(stderr,"------ ------ ------ ------- ---- ---- ---- ---- ---- ----\n");
	for( xi = 0; cext = types[xi].ext; xi++ ){
		if( cnt = types[xi].cnt ){
			fprintf(stderr,"%-6s %6d %5.1f%%",
				cext,cnt,(cnt*100)/(float)total);
			if( opt_a || types[xi].itype ){
				fprintf(stderr," %7d %4d %4d %4d %4d %4d %4d",
					types[xi].ixs[E_OK],
					types[xi].ixs[E_CTRL],
					types[xi].ixs[E_NONTEXT],
					types[xi].ixs[E_ENCODED],
					types[xi].ixs[E_BINARY],
					types[xi].ixs[E_EMPTY]+
					types[xi].ixs[E_EOF],
					types[xi].ixs[E_DIR]
					);
			}
			fprintf(stderr,"\n");
		}
	}

	if( Codes[200] || Codes[302] ){
		fprintf(stderr,"\n");
		fprintf(stderr,"  code  count\n");
		fprintf(stderr,"------ ------\n");
		for(i = 0; i < 1000; i++ ){
			if( Codes[i] ){
				fprintf(stderr,"%6d %6d\n",i,Codes[i]);
			}
		}
		fprintf(stderr,"\n");
	}

	fprintf(stderr,"Indexed: %d (with Author: %d+%d)\n",NumPut,
		withAuthor,guessedAuthor);
}

static void Lap();

typedef struct {
	FILE *flist;
	int   flen;
	int   optr;
	char *strip;
	char *pre;
	char *conv;
	FILE *out;
	FILE *descf;
} Opts;

static scanfile(file,dir,opts,optr)
	char *file;
	Opts *opts;
{	char path[1024];

	if( optr < 0 )
		return;

	if( strcmp(file,".") == 0 || strcmp(file,"..") == 0 )
		return;

	sprintf(path,"%s/%s",dir,file);
	if( fileIsdir(path) ){
		Scandir(path,scanfile,path,opts,optr-1);
	}else{
		fprintf(opts->flist,"%s\n",path);
		opts->flen++;
		if( opts->flen % 100 == 0 ){
			Lap(0,NULL,"%d files found\n",opts->flen);
		}
	}
	return 0;
}
static scanUrls();
static scandir(url,optr,strip,pre,conv,out,descf)
	char *url,*strip,*pre,*conv;
	FILE *out,*descf;
{	Opts opts;

	if( optr <= 0 ){
		return;
	}
	Lap(1,NULL,"scanning directory [%s]\n",url);
	opts.flist = tmpfile();
	opts.flen = 0;
	opts.optr = optr;
	opts.strip = strip;
	opts.pre = pre;
	opts.conv = conv;
	opts.out = out;
	opts.descf = descf;

	Scandir(url,scanfile,url,&opts,optr);
	Lap(1,NULL,"%d files under [%s]\n",opts.flen,url);
	Start = Time();

	fflush(opts.flist);
	fseek(opts.flist,0,0);
	scanUrls(opts.flist,optr-1,strip,pre,conv,out,descf);
	fclose(opts.flist);
}

static int totallen;
xany2fdif(ix,pre,strip,url,xconv,in,out,descf,itypep)
	char *pre,*strip,*url,*xconv;
	FILE *in,*out,*descf;
	int *itypep;
{	int mi;
	int ixs;
	char sub[1024];
	int poff = 0;
	int noff;
	int sItype = Itype;

	for( mi = 1;; mi++ ){
		sprintf(sub,"?n=%d&off=%d",mi,ftell(in));
		ixs = any2fdif(pre,strip,url,mi,sub,xconv,in,out,descf,itypep);

		noff = ftell(in);
		totallen += (noff - poff);
		poff = noff;
		Lap(0,totallen,0);

		if( ix == 0 && (*itypep == T_MAIL || *itypep == T_MBOX) ){
			types[0].cnt -= 1;
			ix = 2;
			types[ix].cnt += 1;
		}
		types[ix].ixs[ixs] += 1;

		if( *itypep == T_MBOX && !feof(in) ){
			Itype = T_MBOX;
			continue;
		}
		break;
	}
	Itype = sItype;
}
static scanUrls(flist,optr,strip,pre,conv,out,descf)
	FILE *flist;
	char *strip,*pre,*conv;
	FILE *out,*descf;
{	char url[1024],*dp;
	char buff[0x10000];
	FILE *in;
	int size,octime,omtime,oatime;
	int ix;
	int itype;
	char *fgot;

	for(;;){
		fgot = fgets(url,sizeof(url),flist);
		Lap(fgot==NULL,totallen,0);

		if( fgot == NULL )
			break;
		if( dp = strpbrk(url,"\r\n") )
			*dp = 0;
		++NumAny;

		printIfText = 0;
		if( !doindextype(url,&ix) ){
			if( opt_a == 0 )
				continue;
			else	printIfText = 1;
		}

		in = NULL;
		if( isFullURL(url) ){
			size = 0;
			octime = 0;
			omtime = 0;
			oatime = 0;
			in = URLget(url,0,NULL);
			if( in != NULL && !feof(in) ){
				fseek(in,0,0);
				itype = T_HTTP;
			}
		}else{
			if( fileIsdir(url) ){
				scandir(url,optr,strip,pre,conv,out,descf);
			}
		    if( File_sizetime(url,&size,&octime,&omtime,&oatime)==0 )
			in = fopen(url,"r");
		}
		if( in != NULL ){
			int code;
			char *xconv;
			Fsize = size;
			Mtime = omtime;
			Atime = oatime;
			itype = 0;

			xconv = getConv(url);
			if( xconv == 0 )
				xconv = conv;

			xany2fdif(ix,pre,strip,url,xconv,in,out,descf,&itype);

			fclose(in);
			code = set_utimes(url,oatime,omtime);
		}

		if( MaxPut && MaxPut <= NumPut ){
			dumptypes();
			exit(0);
		}

	}
}

static makedir(dir)
	char *dir;
{
	if( File_is(dir) ){
		if( File_isreg(dir) ){
			fprintf(stderr,"Is flat file: %s\n",dir);
			exit(-1);
		}
	}else{
		if( mkdir(dir,0750) != 0 ){
			fprintf(stderr,"Can't create: %s\n",dir);
			exit(-1);
		}
	}
}
static scanFilelist(outbase,outname,outmode,strip,pre,conv,flist,optr)
	char *outname,*outmode,*strip,*pre,*conv;
	FILE *flist;
{	char outdir[1024],path[1024],*dp,*dbname,outnameb[1024],*env;
	char base[1024];

	if( strcmp(outname,"-") == 0 ){
		Out = stdout;
	}else{
		if( outbase || strchr(outname,'/') == 0 ){
			if( fileIsdir("bank") ){
				sprintf(base,"bank/%s/",outname);
				outname = base;
			}else
			if( env = getenv("FSXHOME") ){
				sprintf(base,"%s/bank/%s/",env,outname);
				outname = base;
			}else
			if( fileIsdir("../bank") ){
				sprintf(base,"../bank/%s/",outname);
				outname = base;
			}else{
			    sprintf(base,"%s/%s",getenv("HOME"),indexbase);
			    if( fileIsdir(base) ){
				sprintf(base+strlen(base),"/%s/",outname);
				outname = base;
			    }
			}
		}
		if( strtailchr(outname) == '/' ){
			strcpy(outdir,outname);
			outdir[strlen(outdir)-1] = 0;
			makedir(outdir);
			if( dp = strrchr(outdir,'/') ){
				dbname = dp+1;
			}else	dbname = outdir;
			sprintf(outnameb,"%s/%s",outdir,dbname);
			outname = outnameb;
		}
		if( !opt_u ){
			sprintf(path,"%s.fdif",outname);
			Out = fopen(path,outmode);
			fprintf(stderr,"FDIF file: %s\n",path);

			sprintf(path,"%s.desc",outname);
			Descf = fopen(path,outmode);
			fprintf(stderr,"Desc file: %s\n",path);

			sprintf(path,"%s.summ",outname);
			Summf = fopen(path,outmode);
			fprintf(stderr,"Summary file: %s\n",path);
		}
	}
	if( opt_u ){
		updateSrt(outname,strip,pre);
		return;
	}
	if( Out == NULL ){
		fprintf(stderr,"Error: %s\n",outname);
		exit(-1);
	}
	scanUrls(flist,optr,strip,pre,conv,Out,Descf);
}
updateSrt(base,strip,pre)
	char *base,*strip,*pre;
{	char line[1024],path[1024];
	int off,size,mtime,atime,crc,nsize,nmtime,natime;
	int pi;
	FILE *summf;
	FILE *atimef;
	int plen = strlen(pre);
	int slen = strlen(strip);

	sprintf(path,"%s.sum",base);
	summf = fopen(path,"r");
	fprintf(stderr,"Summary file: %X %s\n",summf,path);
	if(summf == NULL){
		sprintf(path,"%s.summ",base);
		summf = fopen(path,"r");
		fprintf(stderr,"Summary file: %X %s\n",summf,path);
		if(summf == NULL){
			return;
		}
	}

	sprintf(path,"%s.atime.srt",base);
	atimef = fopen(path,"w");
	fprintf(stderr,"Atime file: %X %s\n",atimef,path);
	if(atimef == NULL)
		return;

 fprintf(stderr,"+++ update sort %X(%d)  summary %X(%d/%d)\n",
atimef,ftell(atimef),summf,ftell(summf),file_size(fileno(summf)));

	for( pi = 0;; pi++ ){
		if( fgets(line,sizeof(line),summf) == NULL )
			break;
		if( sscanf(line,"%x %x %x %x %d %[^\r\n]",
			&off,&atime,&mtime,&crc,&size,path) != 6 )
		{
			continue;
		}
		if(*pre && strncmp(path,pre,plen) == 0 ){
			bcopy(path+plen,path,strlen(path+plen)+1);
		}
		if(*strip){
			Strins(path,strip);
		}
		if( File_sizetime(path,&nsize,NULL,&nmtime,&natime) == 0 ){
if( opt_v )
if( natime != atime )
printf(">%d (%5d) %X %X %s\n",atime!=natime,pi,atime,natime,path);
			natime = htonl(natime);
			fwrite(&natime,1,sizeof(natime),atimef);
		}else{
 fprintf(stderr,"BAD[%s]\n",path);
			fseek(atimef,4,1);
		}
	}
	fflush(atimef);
 fprintf(stderr,"#### %d / %d\n",ftell(atimef),file_size(fileno(atimef)));
}

static usage(ac,av,code)
	char *av[];
{	char *ver = DELEGATE_verdate();
	if( ver ){
		fprintf(stderr,"Any2fdif on %s\n",ver);
	}
 fprintf(stderr,"\n");
 fprintf(stderr,
"Usage: %s [indexname] [[-c cnv] [-s spfx] [-p ppfx] [-f listfile]]*\n",
 av[0]);
 fprintf(stderr,"\n\
Generate a 'FDIF' file to be input to FreyaSX indexer 'findex'.  It outputs\n\
to a FDIF file named 'indexname' (or to stdout by default).  It inputs\n\
documents from files listed in 'listfile' (or stdin by default), then apply\n\
filter command 'cnv' for each file (if specified), then convert it to FDIF\n\
format to be output.  The name of each document can be full URL or name of\n\
local file.  When the name is that of local file, the URL for it can be\n\
created from each file name, stripping prefix string 'spfx' (if specified),\n\
and adding prefix string 'ppfx' (if specified).\n");
 fprintf(stderr,"\nExample:\n");
 fprintf(stderr,"\
  %% find /web/data -type f -name \"*.html\" -print > webidx.list\n");
 fprintf(stderr,"\
  %% %s webidx -s /web/data/ -p http://www.my.org/ -f web.list\n",av[0]);
 fprintf(stderr,"\
  %% findex webidx\n\n");
 fprintf(stderr,"\
  (doing above in a single step)\n\
  %% %s -r /web/data -s /web/data -p http://www.my.org/ | findex webidx\n\n",
av[0]);
 fprintf(stderr,"\
  %% find /web/data | %s | findex webidx\n",av[0]);
 fprintf(stderr,"\
  %% echo 'http://www.delegate.org' | %s | findex web\n",av[0]);
 fprintf(stderr,"\nOptions:\n\
  indexname        output to the indexname\n\
  -f listfile      scan each file listed in the listfile\n\
  -r directory     recursively scan files under the directory\n\
  -s prefix        strip the prefix from each file-name\n\
  -p prefix        insert the prefix string to be URL\n\
  -c 'command'     preprocess command (as a shell command)\n\
  -c.ext 'command' preprocess command for files with .ext extension\n\
  -v               verbose\n\
");
	exit(code);
}

extern int MIME_CONV;
extern int MIME_SPACE_ENCODING;

any2fdif_main(ac,av)
	char *av[];
{	int ai;
	char *a1;
	char *outname = "default";
	char *outmode = "w";
	int outbase = 0;
	char *pre = "";
	char *strip = "";
	FILE *in = stdin;
	FILE *flist = NULL;
	FILE *tmp;
	char execpath[256],*env;
	int numin = 0;
	int numout = 0;
	char *conv = 0;
	FILE *Tmp4 = 0;
	int optr = 0;

	/* these are disalbed in delegated.c */
	MIME_CONV = 0xFFFFFFFF; /* enable all MIME conversion */
	MIME_SPACE_ENCODING = 2; /* default encoding -- typeB */

	AFenv = calloc(1,sizeof(AFEnv));

	Start = Time();
	toFullpathENV("PATH",av[0],"r",execpath,sizeof(execpath));
	env = getenv("LIBPATH");
	if( env == 0 ){
		char *dp,xd[256],rx[256],libenv[1024];
		if( dp = strrchr(execpath,'/') ){
			Strncpy(xd,execpath,dp-execpath+1);
		}else	strcpy(xd,".");
		sprintf(libenv,"LIBPATH=%s:%s/../lib:%s/../etc",xd,xd,xd);

		if( realpath(execpath,rx,sizeof(rx)) ){
			if( dp = strrchr(rx,'/') )
				*dp = 0;
		sprintf(libenv+strlen(libenv),":%s:%s/../lib:%s/../etc",
				rx,rx,rx);
		}
		putenv(strdup(libenv));
	}

	if( ac < 2 ){
		if( isatty(fileno(stdin)) )
			usage(ac,av,-1);
	}

	for( ai = 1; ai < ac; ai++ ){
		a1 = av[ai];
		if( strcmp(a1,"-v") == 0 ){
			opt_v = 1;
		}else
		if( strcmp(a1,"-a") == 0 ){
			opt_a = 1;
		}else
		if( strcmp(a1,"-o") == 0 || strcmp(a1,"-a") == 0 ){
			numout++;
			if( ai+1 < ac ){
				outname = av[++ai];
				outmode = strcmp(a1,"-o")==0 ? "w" : "a";
				outbase = 0;
			}
		}else
		if( strcmp(a1,"-b") == 0 ){
			if( ai+1 < ac ){
				outname = av[++ai];
				outmode = "w";
				outbase = 1;
			}
		}else
		if( strncmp(a1,"-c",2) == 0 ){
			if( ai+1 < ac ){
				if( a1[2] == '.' ){
					setConv(a1+3,av[++ai]);
				}else{
					conv = av[++ai]; 
				}
			}
		}else
		if( strncmp(a1,"-f",2) == 0 ){
			numin++;
			if( ai+1 < ac )
				++ai;
		}else
		if( strcmp(a1,"-p") == 0 ){
			if( ai+1 < ac )
				pre = av[++ai];
		}else
		if( strcmp(a1,"-e") == 0 ){
			if( ai+1 < ac ){
				void *sed_new();
				UrlSed = sed_new();
				sed_compile(UrlSed,av[++ai]);
			}
		}else
		if( strcmp(a1,"-m") == 0 ){
			/* -m "http://%S/%S/%S/%d/%d http://%S/%S/%S/%S%S" */
			if( ai+1 < ac ){
				char *mount = av[++ai];
				char pat[256];
				char *dp = wordscanX(mount,pat,sizeof(pat));
				UrlMount[0] = strdup(pat);
				wordscanX(dp,pat,sizeof(pat));
				UrlMount[1] = strdup(pat);
			}
		}else
		if( strncmp(a1,"-r",2) == 0 ){
			/* -r[N] recursion depth N */
			if( a1[2] )
				optr = atoi(&a1[2]);
			else	optr = 16;
		}else
		if( strcmp(a1,"-s") == 0 ){
			if( ai+1 < ac )
				strip = av[++ai];
		}else
		if( strcmp(a1,"-u") == 0 ){
			opt_u = 1;
			outmode = "r+";
		}else
		if( a1[0] == '-' && isdigit(a1[1]) ){
			MaxPut = atoi(a1+1);
		}else
		if( a1[0] != '-' && ai == 1 ){
			outname = a1;
			outmode = "w";
			outbase = 1;
		}
	}
	if(opt_u){
		scanFilelist(outbase,outname,outmode,strip,pre,conv,flist,optr);
		return;
	}
	if( numout == 0 ){
		if( !isatty(fileno(stdout)) ){
			outname = "-";
			outmode = "a";
			outbase = 0;
			fprintf(stderr,"+++ -o -\n");
		}
	}

	for( ai = 1; ai < ac; ai++ ){
		a1 = av[ai];
		if( strcmp(a1,"-v") == 0 ){
		}else
		if( strcmp(a1,"-a") == 0 ){
		}else
		if( strcmp(a1,"-o") == 0 ){
			if( ai+1 < ac ){
				++ai;
			}
		}else
		if( strcmp(a1,"-b") == 0 ){
			if( ai+1 < ac ){
				++ai;
			}
		}else
		if( strncmp(a1,"-c",2) == 0 ){
			if( ai+1 < ac ){
				if( a1[2] == '.' ){
				}else{
					conv = av[++ai]; 
				}
			}
		}else
		if( strncmp(a1,"-f",2) == 0 ){
			NumUrl = 0;
			switch(a1[2]){
				case 't': Itype = T_TEXT; break;
				case 'm': Itype = T_MAIL; break;
				case 'h': Itype = T_HTML; break;
			}
			if( ai+1 < ac ){
				if( strcmp(av[++ai],"-") == 0 )
					flist = stdin;
				else	flist = fopen(av[ai],"r");
				if( flist == NULL ){
					fprintf(stderr,"Error: %s\n",av[ai]);
					exit(-1);
				}
				scanFilelist(outbase,outname,outmode,strip,pre,conv,flist,optr);
			}
		}else
		if( strcmp(a1,"-p") == 0 ){
			if( ai+1 < ac )
				pre = av[++ai];
		}else
		if( strcmp(a1,"-e") == 0 ){
			if( ai+1 < ac ){
				ai++;
			}
		}else
		if( strcmp(a1,"-m") == 0 ){
			if( ai+1 < ac ){
				ai++;
			}
		}else
		if( strncmp(a1,"-r",2) == 0 ){
			/* -r[N] recursion depth N */
			if( a1[2] )
				optr = atoi(&a1[2]);
			else	optr = 16;
		}else
		if( strcmp(a1,"-s") == 0 ){
			if( ai+1 < ac )
				strip = av[++ai];
		}else
		if( a1[0] == '-' ){
		}else{
			if( ai == 1 ){
				/* regard 1st arg as -b arg */
				if( outbase == 0 ){
					fprintf(stderr,"+++ -b %s\n",a1);
					outname = a1;
					outmode = "w";
					outbase = 1;
				}
			}else{
				if( Tmp4 == 0 )
					Tmp4 = getTmp(TMP4);
				fprintf(Tmp4,"%s\n",a1);
			}
		}
	}
	if( numin == 0 ){
		if( !isatty(fileno(stdin)) ){
			fprintf(stderr,"+++ -f -\n");
			flist = stdin;
			scanFilelist(outbase,outname,outmode,strip,pre,conv,flist,optr);
		}
	}
	if( Tmp4 != 0 ){
		fflushTmp(Tmp4);
		scanFilelist(outbase,outname,outmode,strip,pre,conv,Tmp4,optr);
	}
	dumptypes();
}

typedef struct {
	int	crc;
	int	len;
} CRC;
static addCRC(crc,str,len)
	CRC *crc;
	char *str;
{
	crc->crc = strCRC32add(crc->crc,str,len);
	crc->len += len;
}

static encEnt(crc,out,tag,attr,buf)
	CRC *crc;
	FILE *out;
	char *tag,*attr,*buf;
{	char outb[2048];

	addCRC(crc,buf,strlen(buf));
	addCRC(crc,"",1);

	encodeEntitiesX(buf,outb,sizeof(outb));
	fprintf(out,"<%s",tag);
	if( *attr ) fprintf(out," %s",attr);
	fprintf(out,">\n%s\n</%s>\n",outb,tag);
}

#define DESCBLOCKSIZE	256
typedef struct {
	int	d_size;
	int	d_date;
	int	d_lastmod;
	char	d_url[DESCBLOCKSIZE-(3*sizeof(int))];
	/*
	char	d_author[];
	char	d_title[];
	char	d_digest[];
	*/
} DescRecord;
static makeDesc(Desc,fsize,mtime,digest)
	DescRecord *Desc;
	char *digest;
{	int rsiz,ulen,alen,tlen,dlen;
	char *dp,*dx;

	Desc->d_size = htonl(fsize);
	Desc->d_date = 0;
	Desc->d_lastmod = htonl(mtime);

	rsiz = sizeof(DescRecord) - ((int)&Desc->d_url - (int)Desc);
	ulen = strlen(Url) + 1; 
	alen = strlen(Author) + 1; 
	tlen = strlen(Title) + 1; 
	dlen = strlen(digest) + 1; 
	if( rsiz < ulen+alen+tlen )
		if( (rsiz*2)/3 < ulen ) ulen = (rsiz*2)/3;
	if( rsiz < ulen+alen+tlen )
		if( rsiz/3 < alen ) alen = rsiz/3;
	if( rsiz < ulen+alen+tlen )
		if( rsiz < tlen ) tlen = (rsiz*3)/4;
	if( rsiz < ulen+alen+tlen+dlen )
		dlen = rsiz - (ulen+alen+tlen);
	dp = Desc->d_url;
	dx = Desc->d_url + (sizeof(Desc->d_url)-1);
	dp = wbstrcpy(dp,dx,Url,ulen);
	dp = wbstrcpy(dp,dx,Author,alen);
	dp = wbstrcpy(dp,dx,Title,tlen);
	dp = wbstrcpy(dp,dx,digest,dlen);
}
static skipLine(line)
	char *line;
{	char *dp,ch;

	if( strncasecmp(line,"-----BEGIN",10)==0 )
		return 3;

	if( strncasecmp(line,"In message",10)==0
	 || strncasecmp(line,"In article",10)==0
	 || strncasecmp(line,"In <",4)==0
	 || strncasecmp(line,"On ",3)==0 && (
		   strstr(line,"wrote")
		|| strstr(line,")\n")
		|| strstr(line,">\n")
	    )
	 || ((dp = strskip(line,"wrote"  )) && strstr(dp,">\n"))
	 || ((dp = strskip(line,"said:"  )) && (*dp==' '||*dp=='\n'))
	 || ((dp = strskip(line,"wrote:" )) && (*dp==' '||*dp=='\n'))
	 || ((dp = strskip(line,"writes:")) && (*dp==' '||*dp=='\n'))
	)
		return 1;

	if( line[0] == '>'
	 || line[0] == '|'
	 || strncmp(line," >",2) == 0
	 || strncmp(line," |",2) == 0
	)
		return 1;

	for( dp = line; ch = *dp; dp++ ){
		if( !isalnum(ch) && !isspace(ch)
		 && ch != '.' && ch != '-' && ch != '_' )
			break;
	}
	if( *dp == '>' )
		return 1;

	return 0;
}

static scanHtml0(inb,charset)
	char *inb,*charset;
{	char *dp,nam[32],con[256];
	int si,na;

	dp = inb;
	for( si = 0; si < 8 && (dp = strcasestr(dp,"<META")); si++ ){
		dp += 5;
		na = scanAttrs(dp,4, "HTTP-EQUIV",nam,sizeof(nam),
			"CONTENT",con,sizeof(con));
		if( na != 2 )
			continue;
		if( strcaseeq(nam,"Content-Type") ){
			getCharset("HTML",charset,con);
		}
	}
}
static makeUrl(url,usiz,pre,path)
	char *url,*pre,*path;
{	char *dp,*sp;

	sprintf(url,"%s%s",pre,path);
	if( strtailstr(url,"/=") ){
		/* index.html or so cached by DeleGate */
		url[strlen(url)-1] = 0;
	}
	/* URL path is escaped to be used as a file name of cache */
	url_unescape(url,url,usiz,"*?%@=");

	for( sp = url; *sp; sp++ ){
		if( *sp == ':' ){
			sp++;
			if( *sp == '/' )
				sp ++;
			break;
		}
	}
	dp = sp;
	for(; *sp; sp++ ){
		*dp++ = *sp;
		if( sp[0] == '/' ){
			while( sp[1] == '/' ){
				sp++;
			}
		}
	}
	*dp = 0;
	if( UrlSed ){
		char buf[0x1000];
		sed_execute1(UrlSed,url,buf);
		Strncpy(url,buf,usiz);
	}
	if( UrlMount[0] ){
		char buf[0x1000],*rsp,*rfp;
		UTag *uv[33],ub[32];
		int uc;
		uvinit(uv,ub,32);
		Strncpy(buf,url,sizeof(buf));
		uc = uvfromsfX(buf,0,UrlMount[0],uv,&rsp,&rfp);
		if(rsp[0] == 0 && rfp[0] == 0 ){
			uvtosf(url,usiz,UrlMount[1],uv);
		}
	}
}

/* avoid multi-bytes char is broken in receiver line buffer (findex) */
void
fputsX(str,out)
	char *str;
	FILE *out;
{	char *sp,ch;
	int pch = '\n';
	int len;
	int do_break = 0;
/*
	fputs(str,out);
*/
	len = 0;
	for( sp = str; (ch = *sp) != 0; sp++ ){
		if( ch == '\n' ){
			len = 0;
			do_break = 0;
		}else{
			if( do_break ){
				if( (ch & 0x80) == 0 ){
/*
 fprintf(stderr,"#### ADD NL-A ch=[%c] len=%d\n",ch,len);
*/
					putc('\n',out);
					len = 0;
					do_break = 0;
				}
			}else{
				if( 1024 < len ){
					do_break = 1;
				}
			}
			len++;
		}
		putc(ch,out);
		pch = ch;
	}
	if( pch != '\n' ){
/*
 fprintf(stderr,"#### ADD NL-B pch=%X len=%d\n",0xFF&pch,len);
*/
		putc('\n',out);
	}
}
scanText(in,out,charset,apath)
	FILE *in,*out;
	char *charset,*apath;
{	char inb[16*1024],*ip,*op;
	char outb[32*1024]; /* for SJIS 1byte kana -> EUC 2byte kana */
	int nb,rcc,ri,ch;
	int bodysiz = 0;

	for( nb = 0; rcc = fread(inb,1,sizeof(inb)-1,in); nb++ ){
		inb[rcc] = 0;
		if( charset && charset[0] == 0 && nb == 0 ){
			scanHtml0(inb,charset);
			if( charset[0] ){
				CCX_setincode(Ccx,charset);
			}
		}
		for( ri = 0; ri < rcc; ri++){
			ch = 0xFF & inb[ri];
			if( ch == 0 ){
				if( opt_v )
				fprintf(stderr,"binary file.\n",Url);
				return E_BINARY;
			}
		}
		CCXexec(Ccx,inb,strlen(inb),outb,sizeof(outb));
		bodysiz += rcc;
		fputsX(outb,out);
	}
	if( bodysiz == 0 ){
		if( 1 /* without .txt or .html suffix */ ){
			if( opt_v )
			fprintf(stderr,"empty file.\n");
			return E_EMPTY;
		}
	}
	return 0;
}

int sysfilter(char *conv,FILE *in,FILE *out);
any2fdif(pre,strip,apath,mi,sub,conv,ain,out,descf,itypep)
	char *pre,*strip,*apath,*sub,*conv;
	FILE *ain,*out,*descf;
	int *itypep;
{	FILE *in = ain;
	char *path = apath;
	char head[256];
	int ismbox = 0;
	char date[64];
	struct tm *tm; int ch,issp,wassp;
	char inb[16*1024],*ip,*op;
	char outb[32*1024]; /* for SJIS 1byte kana -> EUC 2byte kana */
	int topoff;
	int itype = 0;
	char digest[256],*dp,*dx,*cp;
	int ic;
	DescRecord Desc;
	int skip,skiphead;
	FILE *Tmp0,*Tmp1;
	CRC crcb = {0,0}, *crc = &crcb;
	int pch,ite;
	int off0;
	char ctype[64];
	char charset[64];
	int ctime,mtime,atime;
	int soff;
	char prevb[1024];
	int noauth;
	int copymark;
	int ecode = 0;
	char cwd[256];
	getcwd(cwd,sizeof(cwd));

	if( strncmp(path,strip,strlen(strip)) == 0 )
		path += strlen(strip);
	if( strncmp(path,"./",2) == 0 )
		path += 2;
	if( fileIsdir(path) ){
		return E_DIR;
	}
	if( conv != NULL ){
		FILE *Tmp3;
		Tmp3 = getTmp(TMP3);
		ftruncate(fileno(Tmp3),(off_t)0);
		sysfilter(conv,in,Tmp3);
		fseek(Tmp3,0,0);
		in = Tmp3;
	}

	Title[0] = 0;
	Keywd[0] = 0;
	Descr[0] = 0;
	Heads[0] = 0;
	Author[0] = 0;
	Address[0] = 0;
	Links[0] = 0;
	Location[0] = 0;
	XUri[0] = 0;
	XRefs[0] = 0;
	ctype[0] = 0;
	charset[0] = 0;
	digest[0] = 0;

	CCXcreate("*",ccx_outcode,Ccx);
	CCXthru8(Ccx,thru8);
	CCXdisable = 0;

	topoff = ftell(in);
	soff = ftell(out);
	if( fgets(head,sizeof(head),in) == NULL ){
		return E_EOF;
	}
	if( strncmp(head,"From ",5) == 0 ){
		ismbox = 1;
	}

	itype = Itype;
	if( Itype == T_MBOX ){
		/* MBOX */
	}else
	if( strncmp(head,"HTTP/",5) != 0 ){
		int ismail;
		fseek(in,topoff,0);
		ismail = isRFC822(in);
		if( itype == T_MAIL ){
			if( ismail <= 0 ){
				return E_BINARY;
			}
		}else{
			if( 0 < ismail ){
/*
 fprintf(stderr,"#### ISMAIL %5d %s\n",ismail,apath);
*/
				itype = T_MAIL;
			}
		}
	}else{
		int code = 0;
		sscanf(head,"HTTP/%*s %d",&code);
		Codes[code%1000] += 1;
		if( code < 200 || 300 <= code ){
			if( opt_v )
			fprintf(stderr,"[%s%s] not user data (%d)\n",pre,path,
				code);
			return E_CTRL;
		}
		while( fgets(head,sizeof(head),in) != NULL ){
			char fnam[64],fval[128];
			if( *head == '\r' || *head == '\n' ){
				Fsize -= ftell(in);
				break;
			}
			scan_field1(head,fnam,sizeof(fnam),fval,sizeof(fval));
			if( strcaseeq(fnam,"Content-Type") ){
				getCharset("HEAD",charset,fval);
				Strncpy(ctype,fval,sizeof(ctype));
				if( dp = strchr(fval,';') )
					*dp = 0;
				if( streq(fval,"text/html") )
					itype = T_HTML;
				else
				if( strstr(fval,"application/xhtml") )
					itype = T_HTML;
				else
				if( streq(fval,"text/plain") )
					itype = T_TEXT;
				else
				if( streq(fval,"application/x-javascript")
				 || streq(fval,"application/javascript")
				 || streq(fval,"text/javascript")
				)	itype = T_JS;
			}else
			if( strcaseeq(fnam,"Last-Modified") ){
				Mtime = scanHTTPtime(fval);
			}else
			if( strcaseeq(fnam,"Content-Encoding") ){
				if( opt_v )
				fprintf(stderr,"[%s%s] encoded (%s)\n",
					pre,path,fval);
				return E_ENCODED;
			}
		}
		if( itype == 0 || itype == T_JS ){
			if( strstr(ctype,"image/") == NULL )
			if( strstr(ctype,"text/css") == NULL )
			if( opt_v )
			fprintf(stderr,"[%s] not text [%s%s]\n",ctype,pre,path);
			return E_NONTEXT;
		}

		if( strncmp(path,"nntp/",5) == 0){
			pre = "nntp://";
			path += 5;
			itype = T_MAIL;
			fseek(in,topoff,0);
		}
		if( strncmp(path,"http/",5) == 0){
			pre = "http://";
			path += 5;
		}
		if( strncmp(path,"https/",6) == 0){
			pre = "http://";
			path += 6;
		}
	}

	makeUrl(Url,sizeof(Url),pre,path);
	NumUrl++;
	if( NumUrl == 1 ){
		fprintf(stderr,"First URL: %s\n",Url);
		fprintf(stderr,"...\n");
	}
	if( opt_v ){
		fprintf(stderr,"%04d [%s] ",NumUrl,apath);
	}

	if( charset[0] ){
		CCX_setincode(Ccx,charset);
	}

	if( itype == T_HTML ){
		Tmp0 = getTmp(TMP0);
		if( ecode = scanText(in,Tmp0,charset,apath) )
			return ecode;

		fflushTmp(Tmp0);
		in = Tmp0;
		CCXdisable = 1;
		/*
		CCXcounts(Ccx);
		*/
	}

	Tmp1 = getTmp(TMP1);
	switch( itype ){
		case T_TEXT: ecode = scanText(in,Tmp1,NULL,apath); break;
		case T_HTML: scanHtml(in,Tmp1,apath); break;
		case T_MBOX:
		case T_MAIL: scanMail(in,Tmp1,apath,ismbox,0); break;
	}
	if( ecode != 0 ){
		return ecode;
	}
	fflushTmp(Tmp1);
	if( Location[0] ){
		makeUrl(Url,sizeof(Url),pre,Location);
	}
	if( itype == T_MAIL && !feof(in) ){
		if( ismbox ){
			itype = T_MBOX;
			Lap(1,NULL,"MBOX %s\n",apath);
		}
	}
	if( itype == T_MBOX ){
		strcat(Url,sub);
	}

/*
	strCRC32add(crc,path,strlen(path));
	strCRC32add(crc,"",1);
*/
/* CRC only for content is desired ? */
	addCRC(crc,path,strlen(path));
	addCRC(crc,"",1);

	fprintf(out,"<DOC HREF=\"%s\">\n",Url); /* encEnt("URL") */
	{
		if( isFullpath(path) ){
			fprintf(out,"<DOCPATH>%s</DOCPATH>\n",path);
		}else{
			char fpath[2048];
			strcpy(fpath,cwd);
			chdir_cwd(fpath,apath,1);
			fprintf(out,"<DOCPATH>%s</DOCPATH>\n",fpath);
		}
	}

	if( strncasecmp(Author,"mailto:",7) == 0 )
		strcpy(Author,Author+7);
	if( Author[0] ){
		if( strstr(Author,"=?") ){
			char buf[256];
			MIME_strHeaderDecode(Author,buf,sizeof(buf));
			CCXexec(Ccx,buf,strlen(buf),Author,sizeof(Author));
		}
	}
	if( Author[0] )
		withAuthor++;

	fprintf(out,"<TEXT WEIGHT=\"3\">\n"); /* encEnt("TEXTW3"); */

	dp = digest;
	dx = digest + (sizeof(digest)-1);
	if( Descr[0] ){
		wbstrcpy(digest,dx,Descr,0);
		dp += strlen(digest);
		if( dp < dx )
			*dp++ = ' ';
	}

	skiphead = 0;
	pch = -1;
	ite = 0;
	prevb[0] = 0;
	noauth = Author[0] == 0;
	copymark = 0;
	for( ic = 0; ; ic++ ){
		if( fgets(inb,sizeof(inb),Tmp1) == NULL )
			break;
		for( ip = inb; ch = *ip; ip++ ){
			if( isspace(ch) && ch != '\n' )
				*ip = ' ';
		}
		addCRC(crc,inb,strlen(inb));
		encodeEntitiesX(inb,outb,sizeof(outb));
		fputs(outb,out);

		if( noauth )
		if( Author[0] == 0 || copymark == 0 && strcasestr(inb,"&copy;") )
		if( prevb[0]
		 || itype == T_HTML && strcasestr(inb,"&copy;")
		 || strcasestr(inb,"Copyright")
		 || strcasestr(inb,"All Right")
		){
			char auth[256];
			int mark = 0;
			auth[0] = 0;
			if( strlen(prevb) + strlen(inb) < sizeof(prevb) ){
				strcat(prevb,inb);
				if( strcasestr(prevb,"&copy;") )
					mark = 1;
				if( copy2auth(prevb,auth,sizeof(auth),apath,0) ){
				}else{
					prevb[0] = 0;
				}
			}else{
				prevb[0] = 0;
			}
			if( auth[0] )
			if( Author[0] == 0 || strcmp(auth,Author) != 0 ){
				copymark = mark;				
				wbstrcpy(Author,Author+(sizeof(Author)-1),auth,0);
			}
		}

		if( skiphead ){
			if( inb[0] == '\r' || inb[0] == '\n' )
				skiphead = 0;
		}else
		if( skiphead == 0 && dp < dx ){
			skip = skipLine(inb);
			skiphead = skip & 2;
			if( skip == 0 ){
				wassp = 1;
				for( ip = inb; ch = *ip; ip++ ){
					int nc = ip[1];
					if( (0x80 & ch) && (0x80 & nc) ){
						if( dp+1 < dx ){
							*dp++ = ch;
							*dp++ = nc;
							ip++;
							pch = ch;
						}
						wassp = 0;
					  	continue;
					}
					if( dx <= dp )
						break;
					if( issp = isspace(ch) )
						ch = ' ';
					if( !(wassp && issp) ){
						if( ch == pch )
							ite++;
						else	ite = 0;
						if( ite < 3 ){
							*dp++ = ch;
							pch = ch;
						}
					}
					wassp = issp;
				}
			}
		}
	}
	*dp = 0;

	crc->crc = strCRC32end(crc->crc,crc->len);
	if( opt_v ){
		fprintf(stderr,"%08X\r\n",crc->crc);
	}
	fprintf(out,"\n</TEXT>\n");

	if( Author[0] == 0 )
	if( Address[0] != 0 )
	if( strcasestr(Address,"converted") == 0 )
	if( strcasestr(Address,"generated") == 0 )
	if( strstr(Address,"Exp") == 0 )
	{	char *ap;

		if( ap = strcasestr(Address,"mail") ){
			ap += 4;
			if( *ap == ' ' )
				ap++;
			if( *ap == ':' )
				ap++;
			else	ap = Address;
		}else
		if( ap = strcasestr(Address," by ") ){
			ap += 4;
		}else{
			ap = Address;
		}
		copy2auth(ap,Author,sizeof(Author),apath,1);
	}
	if( noauth && Author[0] ){
		guessedAuthor++;
	}
	if( XUri[0]  ) encEnt(crc,out,"URL","",XUri);
	if( Heads[0] ) encEnt(crc,out,"TEXT","WEIGHT=\"2\"",Heads);
	if( Descr[0] ) encEnt(crc,out,"TEXT","WEIGHT=\"1\"",Descr);
	if( XRefs[0] ) encEnt(crc,out,"LINK","",XRefs);
	if( Links[0] ) encEnt(crc,out,"LINK","",Links);
	if( digest[0]) encEnt(crc,out,"DIGEST","",digest);
	if( Author[0]) encEnt(crc,out,"AUTHOR","",Author);
	if( Title[0] ) encEnt(crc,out,"TITLE","",Title);
	if( Keywd[0] ) encEnt(crc,out,"KEYWORD","",Keywd);

	fprintf(out,"<METAX name=DATE>%X</DATE>\n",time(NULL));
	fprintf(out,"<METAX name=LASTMODIFIED>%X</META>\n",Mtime);
	fprintf(out,"<METAX name=LASTACCESSED>%X</META>\n",Atime);
	fprintf(out,"<METAX name=SIZE>%X</META>\n",Fsize);
	fprintf(out,"<METAX name=CRC32>%08X</META>\n",crc->crc);
	fprintf(out,"</DOC>\n");
fflush(out);

	makeDesc(&Desc,Fsize,Mtime,digest);
	if(descf){
		fwrite(&Desc,1,sizeof(Desc),descf);
		fflush(descf);
	}

	NumPut++;
	if( printIfText ){
		fprintf(stderr,"IsText: %s\n",Url);
	}

	if(Summf){
		fprintf(Summf,"%08X %08X %08X %08X %8d %s\n",soff,Atime,Mtime,
		crc->crc,Fsize,apath);
	}
	if( itypep )
		*itypep = itype;
	return E_OK;
}

toMD5dots(char *pfx, char *str, char *dots, int len){
	char md5[64],*dp,*sp;
	int i;
	toMD5(str,md5);

	sp = md5;
	dp = dots;
	if( pfx && *pfx ){
		strcpy(dots,pfx);
		dp += strlen(dp);
	}
	for(i = 0; i < len && *sp; i++){
		if( 0 < i && i % 2 == 0){
			*dp++ = '.';
		}
		*dp++ = *sp++;
	}
	*dp = 0;
}
static scanRefs(char *irefs, char *orefs, int osize){
	int ri;
	char *xp,*dp,*rp,ref1[256],*op,xref1[256];
	op = orefs;
	xp = orefs + (osize-1);
	rp = irefs;

	*orefs = 0;
	for( ri = 0; ; ri++ ){
		rp = strchr(rp,'<');
		if( rp == NULL )
			break;
		rp = wordscanY(rp,ref1,sizeof(ref1),"^>");
		if( *rp == '>' ){
			if( 0 < ri && op < xp ){
				*op++ = ' ';
			}
			strcat(ref1,">");
			Strncpy(op,ref1,xp-op);
			op += strlen(op);

			toMD5dots("x-uri.",ref1,xref1,32);
			Strncpy(op,xref1,xp-op);
			op += strlen(op);
		}
	}
}

scanMail(in,out,apath,ismbox,lev)
	FILE *in,*out;
	char *apath;
{	char line[1024],xline[1024],fnam[32],fval[1024],yline[2*1024];
	char *dp,*ep;
	int li;
	int inUU;
	int topoff;
	int deMime = 0;
	char *lkp = Links,*lkx = Links+(sizeof(Links)-1);

	topoff = ftell(in);
	while( RFC822_fgetsHeaderField(line,sizeof(line),in) != NULL ){
		if( *line == '\r' || *line == '\n' )
			break;

		scan_field1(line,fnam,sizeof(fnam),fval,sizeof(fval));
		if( strcaseeq(fnam,"Content-Type") ){
			if( strncaseeq(fval,"multipart/",10) ){
				if( lev == 0 ){
					deMime |= 1;
					break;
				}
			}
		}else
		if( strcaseeq(fnam,"Content-Transfer-Encoding") ){
			if( strcasestr(fval,"quoted-printable")
			 || strcasestr(fval,"base64") ){
				if( lev == 0 ){
					deMime |= 2;
					break;
				}
			}
		}else
		if( strcaseeq(fnam,"Subject")
		 || strcaseeq(fnam,"From") ){
			if( hide_addr )
				MIME_rewaddrs(hide_addr,line);
			MIME_strHeaderDecode(line,xline,sizeof(xline));
			if( CCXdisable ){
				scan_field1(xline,fnam,sizeof(fnam),fval,sizeof(fval));
			}else{
				CCXexec(Ccx,xline,strlen(xline),yline,sizeof(yline));
				scan_field1(yline,fnam,sizeof(fnam),fval,sizeof(fval));
			}
		}
		if( strcaseeq(fnam,"Message-Id") ){
			int len;
			linescanX(fval,XUri,sizeof(XUri));

			len = strlen(XUri);
			toMD5dots("x-uri.",XUri,XUri+len,32);
		}else
		if( strcaseeq(fnam,"References") ){
			scanRefs(fval,XRefs,sizeof(XRefs));
		}else
		if( strcaseeq(fnam,"Subject") ){
			linescanX(fval,Title,sizeof(Title));
		}else
		if( strcaseeq(fnam,"From") ){
			linescanX(fval,Author,sizeof(Author));
		}else
		if( strcaseeq(fnam,"Date") ){
			Mtime = scanNNTPtime(fval);
		}
	}

	if( lev == 0 && deMime ){
		FILE *Tmp2;
		Tmp2 = getTmp(TMP2);
		fseek(in,topoff,0);

if( ftell(in) != topoff ){
  fflush(in);
  fseek(in,topoff,0);
  fprintf(stderr,"## fseek retried: %d %d\n",topoff,ftell(in));
}

		if( ismbox ){
			FILE *Tmp5 = getTmp(TMP5);
			int li;
			for(li = 0; fgets(line,sizeof(line),in) != NULL; li++){
				if( li != 0 )
				if( strncmp(line,"From ",5) == 0 ){
					backseek(in,strlen(line));
					break;
				}
				fputs(line,Tmp5);
			}
			fflushTmp(Tmp5);
			in = Tmp5;
		}

		PGPdecodeMIME(in,Tmp2,NULL,0x2FF,0,0);
		fflushTmp(Tmp2);
		scanMail(Tmp2,out,apath,ismbox,lev+1);
		return;
	}

	inUU = 0;
	for( li = 0; fgets(xline,sizeof(xline),in) != NULL; li++ ){
		if( ismbox ){
			if( strncmp(xline,"From ",5) == 0 ){
				backseek(in,strlen(xline));
				break;
			}
		}
		if( inUU == 0 ){
			if( strncmp(xline,"begin ",6) == 0 )
			if( isdigit(xline[6]) )
			{
				inUU = 1;
				continue;
			}
			if( dp = strstr(xline,"<URL:") ){
				dp += 5;
				if( ep = strchr(dp,'>') ){
					if( ep-dp+1 < lkx-lkp ){
						Strncpy(lkp,dp,ep-dp+1);
						lkp += strlen(lkp);
						*lkp++ = '\n';
						*lkp = 0;
					}
				}
			}
		}else{
			if( strncmp(xline,"end",3) == 0 ){
				inUU = 0;
				continue;
			}
			continue;
		}
		if( CCXdisable ){
			fputs(xline,out);
		}else{
			CCXexec(Ccx,xline,strlen(xline),yline,sizeof(yline));
			fputs(yline,out);
		}
	}
}
static scanalpha(in,str,size)
	FILE *in;
	char *str;
{	char *dp;
	int i,ch;

	for( i = 0; i < size-1; i++ ){
		ch = getc(in);
		if( !isalpha(ch) ){
			ungetc(ch,in);
			break;
		}
		str[i] = ch;
	}
	str[i] = 0;
}

#define	BUFFED	(0x80000000|' ')

scanHtml(in,tmp,apath)
	FILE *in,*tmp;
	char *apath;
{	int ch,pch,end,ech;
	char *dp,tag[0x10000],tagn[32],attrn[32];
	char nam[32],con[1024];
	int inHead = 0;
	int inTitle = 0;
	int inScript = 0;
	int inStyle = 0;
	int inHeading = 0;
	int inAddress = 0;
	int preisspace = 0;
	char *tip = Title,*tix = Title+(sizeof(Title)-1);
	char *htp = Heads,*htx = Heads+(sizeof(Heads)-1);
	char *adp = Author,*adx = Author+(sizeof(Author)-1);
	char *ddp = Address,*ddx = Address+(sizeof(Address)-1);
	char *lkp = Links,*lkx = Links+(sizeof(Links)-1);
	int bodyoff = ftell(tmp);
	int pushch = -1;
	char buffed[128];
	char authcand[128];
	int asis = 0;
	int ite = 0;
	int ic;
	char buf[256];

	authcand[0] = 0;
	pch = 0;
	asis = 0;
	for( ic = 0; ; ic++ ){
	    if( pushch != -1 ){
		ch = pushch;
		pushch = -1;
		goto INCHAR;
	    }else
	    if( (ch = getc(in)) == EOF ){
		break;
	    }
	    if( asis ){
		asis = 0;
		goto INCHAR;
	    }

	    if( 0 < inScript || 0 < inStyle ){
		if( ch == '<' ){
			ch = getc(in);
			if( ch == '/' ){
				scanalpha(in,tagn,8);
				if( inScript && strcasecmp(tagn,"SCRIPT") == 0
				 || inStyle  && strcasecmp(tagn,"STYLE") == 0
				){
					ch = getc(in);
					if( ch == '>' ){
						if( strcaseeq(tagn,"SCRIPT") )
							inScript--;
						if( strcaseeq(tagn,"STYLE") )
							inStyle--;
					}
				}
			}
		}
            }else
	    if( ch == '<' ){
		ch = getc(in);
		if( ch == EOF )
			break;
		if( ch == '!' ){
			char comment[64];
			if( skipComment(in,comment,sizeof(comment)) == EOF )
				break;
			if( strcaseeq(comment,"--X-Body-of-Message--")
			 || strcaseeq(comment,"-- body=\"start\" --")
			 || strcaseeq(comment,"--beginarticle--")
			){
				fseek(tmp,bodyoff,0);
			}

			if( strncasecmp(comment,"-- email=",9) == 0 ){
				valuescanX(comment+9,authcand,sizeof(authcand));
			}
			if( strncasecmp(comment,"--X-From-R13:",13) == 0 ){
				char *xp;
				linescanX(comment+13,authcand,sizeof(authcand));
				if( xp = strstr(authcand,"--") )
					*xp = 0;
				strrot13(authcand,authcand);
			}
			continue;
		}
		if( ch == '?' ){
			while( !feof(in) ){
				if( getc(in) == '?' )
				if( getc(in) == '>' )
					break;
			}
		}

		if( end = (ch == '/') ){
			ch = getc(in);
		}
		if( !isalpha(ch) ){
			pushch = '<';
			ungetc(ch,in);
			if( end )
				ungetc('/',in);

			if( opt_d )
			fprintf(stderr,"## UNGET TAG <%s%c ##\n",end?"/":"",ch);
			continue;
		}
		ech = fscanTag(in,ch,tag,sizeof(tag));
		if( ech != '>' ){
			if( opt_d )
			fprintf(stderr,"## UNGET TAG <%s%s ##\n",end?"/":"",tag);
		}
		dp = wordscanX(tag,tagn,sizeof(tagn));

		if( strcasecmp(tagn,"HEAD") == 0 ){
			inHead += end ? 0 : 1;
		}else
		if( strcasecmp(tagn,"SCRIPT") == 0 ){
			inScript += end ? -1 : 1;
		}else
		if( strcasecmp(tagn,"STYLE") == 0 ){
			inStyle += end ? -1 : 1;
		}else
		if( strcasecmp(tagn,"TITLE") == 0 ){
			inTitle = end ? 0 : 1;
		}else
		if( (tagn[0]=='H' || tagn[0]=='h') && isdigit(tagn[1]) ){
			if( !end && htp != Heads && htp < htx )
				*htp++ = ',';
			inHeading = end ? 0 : atoi(tag+1);
		}else
		if( strcasecmp(tagn,"LINK") == 0 ){
			if( scanLink(dp,nam,sizeof(nam),con,sizeof(con))==0 )
			if( strcasecmp(nam,"MADE") == 0 ){
				decodeEntitiesX(con,Author,sizeof(Author),1);
				if( adp = strchr(Author,'?') )
					*adp = 0;
				adp = Author + strlen(Author);
			}
		}else
		if( strcasecmp(tagn,"META") == 0 ){
			if( scanMeta(dp,nam,sizeof(nam),con,sizeof(con)) == 0 ){
			if( strcasecmp(nam,"AUTHOR") == 0 ){
				decodeEntitiesX(con,Author,sizeof(Author),1);
				adp = Author + strlen(Author);
			}else
			if( strcasecmp(nam,"COPYRIGHT") == 0 ){
				decodeEntitiesX(con,ddp,ddx-ddp,1);
				ddp += strlen(ddp);
			}else
			if( strcasecmp(nam,"SUBJECT") == 0 ){
				decodeEntitiesX(con,Title,sizeof(Title),1);
				tip += strlen(tip);
			}else
			if( strcasecmp(nam,"DESCRIPTION") == 0 ){
				decodeEntitiesX(con,Descr,sizeof(Descr),1);
			}else
			if( strcasecmp(nam,"KEYWORDS") == 0 ){
				decodeEntitiesX(con,Keywd,sizeof(Keywd),1);
			}
			else
			if( strcasecmp(nam,"Content-Location") == 0 ){
				decodeEntitiesX(con,Location,sizeof(Location),1);
			}
			else
			if( strcasecmp(nam,"Last-Modified") == 0 ){
				int mtime = scanHTTPtime(con);
				if( mtime == 0 || mtime == -1 ){
					fprintf(stderr,"Illegal Date: %s %s\n",
						con,apath);
					Mtime = 1;
				}else{
					Mtime = mtime;
				}
			}
			}
		}else
		if( strcasecmp(tagn,"A") == 0 ){
			if( scanAHREF(dp,con,sizeof(con)) == 0 ){
				if( strncmp(con,"http://",7) == 0 )
				if( strlen(con) < lkx-lkp-1 ){
					Strncpy(lkp,con,lkx-lkp);
					lkp += strlen(lkp);
					*lkp++ = '\n';
				}
				if( authcand[0] == 0 )
				/* if( inHead || inAddress ) */
				if( strncasecmp(con,"mailto:",7) == 0 ){
					char *qp;
					if( qp = strchr(con,'?') )
						*qp = 0;
					wbstrcpy(authcand,authcand+(sizeof(authcand)-1),con,0);
				}
			}
		}else
		if( strcasecmp(tagn,"ADDRESS") == 0 ){
			inAddress = end ? 0 : 1;
		}
	    }else
	    if( ch == '&' ){
		char buf[16];
		int bi = 0;
		buf[bi++] = ch;
		while( bi < sizeof(buf)-1 ){
			ch = getc(in);
			if( ch == EOF )
				break;
			buf[bi++] = ch;
			if( ch != '#' && !isalnum(ch) )
				break;
		}
		buf[bi] = 0;
		if( bi == 6
		 && ch != ';'
		 && strchr(" &<>",ch)
		 && strncaseeq(buf,"&nbsp",5)
		){
			pushch = BUFFED;
			strcpy(buffed," ");
			ungetc(ch,in); /* maybe typo */
		}else
		if( ch == ';' ){
			if( strcaseeq(buf,"&nbsp;") ){
				pushch = ' ';
			}else{
				char ob[32];
				decodeEntitiesX(buf,ob,sizeof(ob),1);
				if( ob[0] != '&' || ob[1] == 0 )
					pushch = ob[0];
				else{
					if( ob[1] == '#' ){
					}else{
						pushch = BUFFED;
						Strncpy(buffed,buf,sizeof(buffed));
					}
				}
			}
		}else{
			backseek(in,strlen(buf));
			asis = 1;
			if( opt_d )
			fprintf(stderr,"## UNGET ENT [%s%c] ##\n",buf,ch);
		}
	    }else INCHAR:{
		if( ch != '\n' && isspace(ch) && preisspace ){
		}else{
			preisspace = isspace(ch);
			if( inTitle ){
				if( tip < tix )
				if( ch != '\n' && ch != '\r' )
					*tip++ = ch;
				continue;
			}
			if( inHeading ){
				if( htp < htx )
				if( ch != '\n' && ch != '\r' )
					*htp++ = ch;
			}
			if( inAddress ){
				if( ddp < ddx ){
					if( ch == '\n' || ch == '\r' )
						ch = ' ';
					if( ch != ' ' || pch != ' ' )
						*ddp++ = ch;
				}
			}
			if( ch == '\n' && ite ){
			}else{
				if( ch == pch )
					ite++;
				else	ite = 0;
				if( ch == BUFFED ){
					fputs(buffed,tmp);
				}else{
					if(ch==CH_COPYR && !CCXwithJP(Ccx)){
						fputs("&copy;",tmp);
					}else{
						putc(ch,tmp);
					}
				}
				pch = ch;
			}
		}
	    }
	}
	*tip = 0;
	*htp = 0;
	*adp = 0;
	*ddp = 0;
	*lkp = 0;

	if( authcand[0] ){
		if( Author[0] ){
		}else{
			wbstrcpy(Author,Author+(sizeof(Author)-1),authcand,0);
		}
	}
	if( Author[0] ){
		url_unescape(Author,Author,sizeof(Author),"\"@ <>/?");
	}
}

/* to be moved into library */
scanAttrs(src,an, nam1,val1,vsiz1,nam2,val2,vsiz2)
	char *src,*nam1,*val1,*nam2,*val2;
{	char *nam,*val,*dp;
	int ai,vsiz,got;

	got = 0;
	dp = src;
	for( ai = 0; ai < an; ai++ ){
		while( isspace(*dp) ) dp++;
		if( *dp == '>' )
			break;
		if( strncasecmp(dp,nam1,strlen(nam1)) == 0 ){
			nam = nam1; val = val1; vsiz = vsiz1;
		}else
		if( nam2 && strncasecmp(dp,nam2,strlen(nam2)) == 0 ){
			nam = nam2; val = val2; vsiz = vsiz2;
		}else{
			int qch;
			for(; *dp && *dp != '='; dp++ );
			if( *dp != '=' )
				break;
			qch = *++dp;
			if( qch == '"' || qch == '\'' ){
				for( dp++; *dp && *dp != qch; dp++);
			}else{
				for(; *dp && !isspace(*dp); *dp++);
			}
			continue;
		}

		dp += strlen(nam);
		while( isspace(*dp) ) dp++;
		if( *dp == '=' ){
			dp++;
			while( isspace(*dp) ) dp++;
			dp = valuescanX(dp,val,vsiz);
			if( *dp == '"' || *dp == '\'' )
				dp++;
			got++;
		}
	}
	return got;
}
scanAHREF(src,href,size)
	char *src,*href;
{
	*href = 0;
	if( scanAttrs(src,4, "HREF",href,size, NULL) == 1 )
		return 0;
	return -1;
}
scanLink(src,nam,nsiz,con,csiz)
	char *src,*nam,*con;
{ 
	*nam = *con = 0;
	if( scanAttrs(src,4, "REL",nam,nsiz, "HREF",con,csiz) == 2
	 || scanAttrs(src,4, "REV",nam,nsiz, "HREF",con,csiz) == 2
	)
		return 0;
	return -1;
}
scanMeta(src,nam,nsiz,con,csiz)
	char *src,*nam,*con;
{ 
	*nam = *con = 0;
	if( scanAttrs(src,4, "NAME",nam,nsiz, "CONTENT",con,csiz) == 2 )
		return 0;
	if( scanAttrs(src,4, "HTTP-EQUIV",nam,nsiz, "CONTENT",con,csiz) == 2 )
		return 0;
	return -1;
}
fscanTag(in,ch,tag,tsiz)
	FILE *in;
	char *tag;
{	char *tp,*tx,quote;
	int pch = 0;

	quote = 0;
	tp = tag;
	tx = tag + (tsiz-1);
	while( tp < tx && ch != EOF ){
		if( ch == '\'' || ch == '"' ){
			if( quote && quote != ch ){
			}else
			if( quote == 0 )
				quote = ch;
			else	quote = 0;
		}
		if( quote == 0 && ch == '>' )
			break;

		if( ch == '\n' || ch == '\r' )
			ch = ' ';
		if( !(isspace(ch) && isspace(pch)) )
			*tp++ = ch;
		pch = ch;
		ch = getc(in);
	}
	*tp = 0;
	return ch;
}
skipComment(in,comment,siz)
	FILE *in;
	char *comment;
{	int ch1,ch,pch,comlev;
	char *cp,*xp;

	ch1 = -1;
	pch = -1;
	comlev = 1;
	xp = comment + (siz-1);
	cp = comment;
	while( (ch = getc(in)) != EOF ){
		if( ch1 == -1 )
			ch1 = ch;

		if( pch == '<' && (ch == '-' || ch1 != '-') ){
			comlev++;
		}else
		if( (pch == '-' || ch1 != '-') && ch == '>' ){
			comlev--;
			if( comlev == 0 )
				break;
		}
		pch = ch;
		if( cp < xp ){
			*cp++ = ch;
		}
	}
	*cp = 0;
	return ch;
}
char *strskip(s,p)
	char *s,*p;
{	char *t;

	if( t = strstr(s,p) )
		return t + strlen(p);
	else	return 0;
}

static FILE *Tmps[8];
FILE *getTmp(ti)
{
	if( Tmps[ti] == NULL )
		Tmps[ti] = tmpfile();
	else{
		clearerr(Tmps[ti]);
		fseek(Tmps[ti],0,0);
	}
	return Tmps[ti];
}
fflushTmp(fp)
	FILE *fp;
{
	fflush(fp);
	ftruncate(fileno(fp),(off_t)ftell(fp));
	fseek(fp,0,0);
}
int sysfilter(filter,in,out)
	char *filter;
	FILE *in,*out;
{	int sv0,sv1;
	FILE *pfp;

	sv0 = dup(0); dup2(fileno(in),0);
	sv1 = dup(1); dup2(fileno(out),1);
	system(filter);
	wait(0);
	dup2(sv1,1); close(sv1);
	dup2(sv0,0); close(sv0);
	return 0;
}

getCharset(where,charset,fval)
	char *where,*charset,*fval;
{	char *dp;

	if( dp = strcasestr(fval,"charset=") ){
		valuescanX(dp+8,charset,32);
		if( strcaseeq(charset,"none")
		 || strcaseeq(charset,"guess")
		){
			*charset = 0;
		}
	}
}
extractAuthor(str,top,author,size,url,dump)
	unsigned char *str,*top,*author,*url;
{	unsigned char *cp,*dp,ch,pch;

	cp = top;
	while( isspace(*cp) )
		cp++;

	if( 128 < size )
		size = 128;
	wbstrcpy(author,author+(size-1),cp,0);

	pch = 0;
	dp = author;
	for( cp = author; ch = *cp; cp++ ){
		if( ch == '\n' && isspace(pch) )
			continue;
		if( isspace(ch) && pch == '\n' )
			continue;
		pch = ch;
		if( ch == '\n' )
			ch = ' ';
		*dp++ = ch;
	}
	*dp = 0;

	if( cp = strcasestr(author,"All Right") )
		*cp = 0;
	for( cp = author; *cp; cp++ ){
		if( strchr("0123456789/-.,() ",*cp) == 0 )
			break;
	}
	if( cp != author )
		strcpy(author,cp);

	for( cp = author; *cp; ){
		if( *cp == ':'
		 || *cp == ';'
		 || *cp == '('
		 || *cp == '|'
		 || *cp == '.' && cp[1] == ' '
		 || *cp == ' ' && cp[1] == ' '
		 || *cp == '-' && cp[1] == ' '
		){
			*cp = 0;
			break;
		}
		cp++;
	}
	for( cp = author+strlen(author)-1; author <= cp; cp-- ){
		ch = *cp;
		if( strchr(" ,.0123456789-/",ch) == 0 )
			break;
		if( isdigit(ch) && author < cp && isalpha(cp[-1]) )
			break;
		*cp = 0;
	}
	if( strncmp(author,"by ",3) == 0 )
		strcpy(author,author+3);
	if( strcmp(author,"by") == 0 )
		*author = 0;

	if( opt_d || dump )
	fprintf(stderr,"#%d#AUTHOR[%s]%d\n#%d#[%s]%s\n",
		NumPut,author,guessedAuthor, NumPut,str,url);

	if( author[0] != 0 ){
		int nsp = 0;
		unsigned char *ap;
		for( ap = author; *ap; ap++ ){
			if( *ap == ' ' ){
				++nsp;
				if( 4 < nsp && 40 < (ap-author) ){
					*ap = 0;
					break;
				}
			}
		}
		return 0;
	}else{
		return 1;
	}
}
copy2auth(copyr,author,size,url,force)
	unsigned char *copyr,*author,*url;
{	unsigned char *cp,*np,*acp;
	int ok = 0;
	int dump = 0;

	if( cp = strstr(copyr,"&copy;") ){
		ok = 1;
		acp = strstr(copyr,"by ");
		if( acp && acp < cp ){ /* by xxx &copy; */
			*cp = 0;
			cp = acp;
		}else{
			cp += 6;
			while( isspace(*cp) )
				cp++;
			if( strncaseeq(cp,"Copyright",9) )
				cp += 9;
		}
	}else
	if( cp = strcasestr(copyr,"Copyright") ){
		cp += 9;
		if( strneq(cp,"ed",2) )
			cp += 2;
		if( *cp == ':' )
			cp++;
		for(;;){
			while( isspace(*cp) )
				cp++;
			if( strncasecmp(cp,"(C)",3) == 0 ){
				cp += 3;
				ok = 1;
				break;
			}
			if( *cp == CH_COPYR ){ /* &copy; */
				cp += 1;
				ok = 1;
				break;
			}
			if( isdigit(*cp) ){
				int y = atoi(cp);
				if( 1900 < y && y < 2100 ){
					cp += 4;
					ok = 1;
					continue;
				}
			}
			if( np = strcasestr(cp,"Copyright") ){
				cp = np + 9;
				continue;
			}
			break;
		}
		if( !ok ){
			if( strcasestr(cp,"All Right") != NULL ){
			/*
			fprintf(stderr,"#### ALLRIGHT %s",copyr);
			*/
			}else
			if( *cp == 0 ){
				return 1;
			}else{
				return 0;
			}
		}
	}else
	if( cp = strcasestr(copyr,"All Rights") ){
		while( isspace(*cp) )
			cp++;
		if( cp = strcasestr(cp,"Reserved by") ){
			cp += 11;
		}else{
			return 0;
		}
	}else
	if( force ){
		cp = copyr;
	}else{
		return 0;
	}
	return extractAuthor(copyr,cp,author,size,url,dump);
}
char *wbstrcpy(dst,dx,src,len)
	char *dst,*dx,*src;
{	char *dp,*sp,ch;
	int ic,in2B;
/*
int l1,l2;
if(len == 0){
Strncpy(dst,src,dx-dst+1);
l1 = strlen(dst);
}
*/
	dp = dst;
	in2B = 0;
	ic = 1; /* reserve for terminator */
	for( sp = src; (len == 0 || ic < len) && (ch = *sp); sp++ ){
		if( dx <= dp )
			break;
		*dp++ = ch;
		ic++;
		if( in2B == 0 ){
			if( ch & 0x80 )
				in2B = 1;
		}else{
			in2B = 0;
		}
	}
	if( in2B ){
		dp--;
	}
	*dp++ = 0;
/*
if(len == 0 ){
l2 = strlen(dst);
if(l1 != l2)printf("A=%d/B=%d/len=%d/in2B=%d\nA: %s\nB: %s\n",
l2,l1,strlen(src),in2B,src,dst);
}
*/
	return dp;
}

extern char **vect_PATH();
FILE *fopen_PATH();
toFullpathPATH(searchpath,file,mode,fullpath,size)
	char *searchpath,*file,*mode,*fullpath;
{	char pathenv[1024];
	char **vpath;
	FILE *xfp;

	if( searchpath == 0 )
		return 0;
	linescanX(searchpath,pathenv,sizeof(pathenv));
	vpath = vect_PATH(pathenv);
	if( xfp = fopen_PATH(vpath,file,mode,fullpath,size) ){
		fclose(xfp);
		return 1;
	}
	return 0;
}
toFullpathENV(envname,file,mode,execpath,size)
	char *envname,*file,*mode,*execpath;
{	char *env;

	if( isFullpath(file) ){
		Strncpy(execpath,file,size);
		return 3;
	}
	if( 0 <= File_size(file) ){
		getcwd(execpath,size);
		chdir_cwd(execpath,file);
		return 2;
	}
	linescanX(file,execpath,size);
	if( env = getenv("PATH") ){
		return toFullpathPATH(env,execpath,"r",execpath,size);
	}
	return 0;
}
realpath(path,realpath,size)
	char *path,*realpath;
	char *size;
{	int len;
	char *dp,link[256];

	len = readlink(path,link,sizeof(link));
	if( len <= 0 )
		return 0;
	link[len] = 0;

	linescanX(path,realpath,size);
	if( dp = strrchr(realpath,'/') ){
		if( dp[1] != 0 )
			*dp = 0;
	}
	chdir_cwd(realpath,link,1);
	return 1;
}

isRFC822(fp)
	FILE *fp;
{	int off,non,fnam,nlen,nf,ic,ch,rcc,ufrom;
	char head[5];

	nf = 0;
	non = 0;
	fnam = 1;
	nlen = 1;

	off = ftell(fp);
	rcc = fread(head,1,5,fp);
	if( rcc != 5 )
		goto EXIT;
	if( ufrom = (strncmp(head,"From ",5) == 0) ){ /* Unix mailbox format */
		for(;;){
			ch = getc(fp);
			if( ch == EOF )
				goto EXIT;
			if( ch == '\n' )
				break;
		}
		ic = ftell(fp) - off;
	}else{
		fseek(fp,off,0);

if(off != ftell(fp)){
  fprintf(stderr,"isRFC822: SEEK ERROR %d %d\n",ftell(fp),off);
  sleep(1);
}
		ic = 0;
	}

	for(; ic < 1024; ic++ ){
		ch = getc(fp);
		if( ch == EOF )
			break;
		if( ch == 0 ){
			non = 1;
			break;
		}
		if( ch == '\r' ){
			ch = getc(fp);
			if( ch != '\n' ){
				non = 2;
				break;
			}
			ungetc(ch,fp);
			continue;
		}
		if( fnam ){
			if( nlen == 0 && ch == '\n' ){
				break;
			}
			if( isalnum(ch) || 0<nlen && ch=='-' ){
				nlen++;
			}else
			if( ch == ':' ){
				if( nlen == 0 ){
					non = 3;
					break;
				}
				fnam = 0;
			}else{
				non = 4;
				break;
			}
		}else{
			if( ch == '\n' ){
				ch = getc(fp);
				if( ch == ' ' || ch == '\t' ){
					/* continue */
				}else{
					nf++;
					if( 5 < nf )
						break;
					ungetc(ch,fp);
					fnam = 1;
					nlen = 0;
				}
			}
		}
	}
EXIT:
	if( feof(fp) )
		clearerr(fp);
	fseek(fp,off,0);
	if( !non && 1 < nf )
		return ic;

/*
 fprintf(stderr,"## ufrom=%d non=%d nf=%d ch=%X nlen=%d\n",
 ufrom,non,nf,ch,nlen);
*/
	return -ic;
}

backseek(FILE *in, int disp){
	int soff = ftell(in);
	int diff;

#ifndef _MSC_VER
	fflush(in); /* to avoid loop on Linux */
#endif
	fseek(in,-disp,1);

	diff = soff - ftell(in);
	if( diff != disp ){
		fprintf(stderr,"#### backseek error %d %d\n",
			diff,disp);
		usleep(100000);
	}
}

static double Prev;
static void Lap(force,outlen,fmt,a,b,c,d,e)
	char *fmt,*a,*b,*c,*d,*e;
{	double Now;

	Now = Time();
	if( Prev == 0 )
		Prev = Now;
	if( !force && (Now-Prev) < 5 )
		return;

	fprintf(stderr,"+++ %6.2f ", Now-Start);
	if( 0 < outlen ){
		fprintf(stderr,
			"%5d %5d (%5.1f docs/s / %6d bytes/s) %d bytes\n",
			NumAny,NumPut, NumPut/(Now-Start),
			(int)(outlen/(Now-Start)), outlen);
	}else
	if( fmt ){
		fprintf(stderr,fmt,a,b,c,d,e);
	}
	Prev = Now;
}
